; This file is made during the LAML configuration process - DO NOT EDIT!

; Load this file from your .emacs file.
; In Windows the .emacs file is normally in c:/
; In Unix the .emacs file is in normally located in the root of your home directory.

; loads the LAML emacs support
(load "/user/normark/scheme/laml.el") 

; -----------------------------------------------------------------------------------

(defun lisp-eval-buffer () 
  (interactive)
  (lisp-eval-region (point-min) (point-max)))

; -----------------------------------------------------------------------------------
; Top level contribution to the Emacs tools menu:

(define-key global-map [menu-bar tools menu-forms-sep-tools]
    '("----"))

(define-key global-map [menu-bar tools laml]
    (cons "Laml" (make-sparse-keymap "Laml")))

; ------------------------------------------------------------------------------------

; Loads the Scheme Elucidator Emacs support.
; Establishes the Elucidator keyboard shortcuts (C-e ...) and the elucidator menu items
; in Tools > LAML > Elucidator Commands.
; You can eliminate the LENO support of LAML by putting a semicolon comment in front of
; the following load command:
(load "/user/normark/scheme/styles/elucidator/elucidator.el")  

; Loads the LENO emacs support.
; Establishes the LENO keyboard shortcuts (C-l ...) and the LENO menu item.
; You can eliminate the LENO support of LAML by putting a semicolon comment in front of
; the following load command:
(load "/user/normark/scheme/styles/lecture-notes/leno.el")

; Load the LAML photo show emacs support.
(load "/user/normark/scheme/styles/xml-in-laml/photo-show/photo-show.el")

; Customize LAML in a new frame.
(defun laml-customize ()
  (interactive)
  (let ((new-frame (make-frame)))
    (select-frame new-frame)
    (customize-group 'laml)))


; -----------------------------------------------------------------------------
; Fundamental laml mode key bindings.

; Arrange that C-o starts asynchronous laml processing
(define-key laml-mode-map "\C-o" 'laml-process-current-buffer)

; Arrange that C-x C-o starts synchronous laml processing
(define-key laml-mode-map "\C-x\C-o" 'laml-sync-process-current-buffer)

; Arrange that C-x C-p makes laml-output vissible.
(define-key laml-mode-map "\C-x\C-p" 'see-laml-output)

; Arrange that C-x C-n calls the LAML nest command:
(define-key laml-mode-map "\C-x\C-n" 'nest)

; Arrange that C-x C-m calls the LAML unnest command:
(define-key laml-mode-map "\C-x\C-m" 'unnest)

; Arrange that C-x C-e calls the LAML embed command:
(define-key laml-mode-map "\C-x\C-e" 'embed)

; Arrange that C-x C-r calls the LAML unembed command:
(define-key laml-mode-map "\C-x\C-r" 'unembed)

; Arrange that C-x C-q calls the LAML split command:
(define-key laml-mode-map "\C-x\C-q" 'split)

; Arrange that C-x C-a calls the LAML unsplit command:
(define-key laml-mode-map "\C-x\C-a" 'unsplit)

; Arrange that C-M-q indents the currently selected S-expression
(define-key laml-mode-map "\C-\M-q" 'indent-sexp)

; Arrange that C-M-x activates lisp-eval-defun (definition af Lisp expression in inferior Lisp job).
(define-key laml-mode-map "\C-\M-x" 'lisp-eval-defun)

; An alias to lisp-eval-defun
; (define-key laml-mode-map "\C-c\C-e" 'lisp-eval-defun) ; eliminated for PP 

; Arrange that C-c C-r activates lisp-eval-region (definition af Lisp expressions in inferior Lisp job).
; (define-key laml-mode-map "\C-c\C-r" 'lisp-eval-region) ; eliminated for PP 


; -----------------------------------------------------------------------------
; Laml mode menu bindings.

(define-key laml-mode-map [menu-bar laml]
    (cons "Laml" (make-sparse-keymap "Laml")))


; -----------------------------------------------------------------------------
; Templates - menu items.

(define-key laml-mode-map [menu-bar laml laml-insert-template]
    (cons "Insert LAML template" (make-sparse-keymap "laml-templates")))

(define-key laml-mode-map [menu-bar laml laml-insert-template other]
      '("Prompt me..." . laml-insert-template))



(define-key laml-mode-map [menu-bar laml laml-insert-template xhtml1-frameset-page]
      '("XHTML1.0 frameset page" . (lambda () (interactive) (laml-insert-template "xhtml1-frameset-page"))))

(define-key laml-mode-map [menu-bar laml laml-insert-template xhtml1-transitional-page]
      '("XHTML1.0 transitional page" . (lambda () (interactive) (laml-insert-template "xhtml1-transitional-page"))))

(define-key laml-mode-map [menu-bar laml laml-insert-template xhtml1-strict-page]
      '("XHTML1.0 strict page" . (lambda () (interactive) (laml-insert-template "xhtml1-strict-page"))))

(define-key laml-mode-map [menu-bar laml laml-insert-template html401-page]
      '("HTML4.01 transitional page" . (lambda () (interactive) (laml-insert-template "html401-page"))))



(define-key laml-mode-map [menu-bar laml menu-forms-sep3]
    '("----"))

; -----------------------------------------------------------------------------
; Scheme evaluation - menu items

(define-key laml-mode-map [menu-bar laml scheme-eval]
     (cons "Evaluate Scheme form(s)" (make-sparse-keymap "Scheme evaluation")))

(define-key laml-mode-map [menu-bar laml scheme-eval lisp-eval-buffer]
      '("Entire buffer" . (lambda () (interactive) (lisp-eval-region (point-min) (point-max)))))

(define-key laml-mode-map [menu-bar laml scheme-eval lisp-eval-region]
      '("Current selection" . lisp-eval-region))

(define-key laml-mode-map [menu-bar laml scheme-eval lisp-eval-defun]
      '("Current form" . lisp-eval-defun))

; -----------------------------------------------------------------------------
; Laml mode menu items

(define-key laml-mode-map [menu-bar laml indent-sexp]
      '("Indent symbolic expression" . indent-sexp))


(define-key laml-mode-map [menu-bar laml menu-forms-sep2]
    '("----"))

(define-key laml-mode-map [menu-bar laml unnest]
      '("Unnest" . unnest))

(define-key laml-mode-map [menu-bar laml nest]
      '("Nest form in form" . nest))

(define-key laml-mode-map [menu-bar laml unsplit]
      '("Unsplit" . unsplit))

(define-key laml-mode-map [menu-bar laml split]
      '("Split string" . split))

(define-key laml-mode-map [menu-bar laml unembed]
      '("Unembed" . unembed))

(define-key laml-mode-map [menu-bar laml embed]
      '("Embed string in form" . embed))

(define-key laml-mode-map [menu-bar laml menu-forms-sep1]
    '("----"))

(define-key laml-mode-map [menu-bar laml process-sync]
      '("Process synchronously" . laml-sync-process-current-buffer))

(define-key laml-mode-map [menu-bar laml process-async]
      '("Process asynchronously" . laml-process-current-buffer))

; End main LAML menu entries



; ---------------------------------------------------------------------------------------------------

(define-key global-map [menu-bar tools laml make-photo-show]
      '("Make new photo show..." . make-laml-photo-show))

(define-key global-map [menu-bar tools laml menu-forms-sep2]
    '("----"))

(define-key global-map [menu-bar tools laml laml-customize]
      '("Customize LAML..." . laml-customize))

(define-key global-map [menu-bar tools laml menu-forms-sep1]
    '("----"))

(define-key global-map [menu-bar tools laml set-interactive-laml-mirror-library]
      '("Set mirror of LAML interaction..." . set-interactive-laml-mirror-library))

(define-key global-map [menu-bar tools laml run-laml-interactively]
      '("Run LAML interactively" . run-laml-interactively))




; ---------------------------------------------------------------------------------------------------
; Special PP support - not for the general LAML distribution:

; Loads Emacs Lisp Scheme stuff
(scheme-mode)


(define-key scheme-mode-map [menu-bar scheme menu-forms-sep-scheme]
    '("----"))

(define-key scheme-mode-map "\C-\M-x" 'lisp-eval-defun)
(define-key scheme-mode-map "\C-\M-y" 'lisp-eval-region)
(define-key scheme-mode-map "\C-\M-z" 'lisp-eval-buffer)

(define-key laml-mode-map "\C-\M-x" 'lisp-eval-defun)
(define-key laml-mode-map "\C-\M-y" 'lisp-eval-region)
(define-key laml-mode-map "\C-\M-z" 'lisp-eval-buffer)


(define-key scheme-mode-map [menu-bar scheme scheme-eval]
      (cons "Evaluate Scheme form(s)" (make-sparse-keymap "Scheme evaluation")))
 
(define-key scheme-mode-map [menu-bar scheme scheme-eval lisp-eval-buffer]
      '("Entire buffer" . lisp-eval-buffer))

(define-key scheme-mode-map [menu-bar scheme scheme-eval lisp-eval-region]
      '("Current selection" . lisp-eval-region))

(define-key scheme-mode-map [menu-bar scheme scheme-eval lisp-eval-defun]
      '("Current form" . lisp-eval-defun))

; Reestablish lisp interaction mode in *scratch*
(lisp-interaction-mode)

; End of PP support
; ---------------------------------------------------------------------------------------------------


