; This file is selected by the LAML installation and configuration process. -  DO NOT EDIT.
; Copied from one of the files in laml-config/emacs-stuff/ to its current location.

; A copy of unix_linux_sisc_laml-execute.el

; Convenient execution of Scheme files from Emacs.
; Top level functions: laml-process-current-buffer, laml-process-buffer,
; and laml-sync-process-current-buffer. 

; The LAML library and programs are written by Kurt Normark, Aalborg University, Denmark.
; Copyright (C) 1999  Kurt Normark, normark@cs.auc.dk.
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

(defun laml-process-current-buffer ()
  "Process the current buffer by SISC. The current buffer is supposed to be a laml buffer.
  Before processing, save the current buffer."
  (interactive)
  (let* ((original-buffer (current-buffer))
         (cur-dir (current-directory))
         (file-path (concat cur-dir (current-file)))
         (buf-name-1 (buffer-name (current-buffer)))
         (buf-name
            (if (buffer-versioned buf-name-1)
                (buffer-without-version buf-name-1)
                buf-name-1))
         (filename-without-extension (file-name-proper buf-name))
         (out-buf (get-buffer-create "laml-output"))
	 (laml-dir-string (concat "(begin (define laml-dir \\\"" laml-dir "\\\")"  "(define (laml-process file . args) (putprop 'argv '\\*environment-variables\\* (cons 'laml args)) (load file)))"))
        )
    (save-buffer)
    (delete-other-windows)
    (split-window)
    (show-buffer (other-window 1) out-buf)
    (set-buffer out-buf)
    (erase-buffer)
    (insert "LAML Emacs Processing") (insert CR)
    (goto-char (point-max))
    (set-buffer original-buffer)
    (start-process "LAML" out-buf "/bin/sh"  "-c" 
      (concat scheme-exec " -e \"" laml-dir-string "\" -x -c laml-process -- " file-path " " filename-without-extension " " cur-dir)
    )
    (other-window 1)
    (enlarge-window source-window-enlargement)
 ))

(defun laml-process-buffer (buffer)
  "Process the laml buffer by SISC. Buffer is the name of a buffer (a string) or a buffer. 
Save buffer before processing"
  (interactive "bWhich buffer: ")
  (let* ((buf-name (if (bufferp buffer) (buffer-name buffer) buffer))
         (the-buffer (if (bufferp buffer) buffer (get-buffer buffer)))
         (buf-name-1
            (if (buffer-versioned buf-name)
                (buffer-without-version buf-name)
                buf-name))
         (out-buf (get-buffer-create "laml-output"))
         (buffer-before (current-buffer))
	 (laml-dir-string (concat "(begin (define laml-dir \\\"" laml-dir "\\\")"  "(define (laml-process file . args) (putprop 'argv '\\*environment-variables\\* (cons 'laml args)) (load file)))"))
	 )
    (set-buffer out-buf) (erase-buffer) (insert "LAML Emacs Processing") (insert CR)  (goto-char (point-max))
    (set-buffer buffer)
    (save-buffer)
    (let* ((file-path (buffer-file-name the-buffer))     ; full path of buffer's file
           (buf-dir  (file-name-directory file-path))    ; directory part of file-path
          )   
      (start-process "LAML" out-buf "/bin/csh"  "-c" 
        (concat scheme-exec " -e \"" laml-dir-string  "\" -x -c laml-process -- " file-path " " (file-name-sans-extension buf-name-1)  " " buf-dir)
      ))
    (display-buffer out-buf)
    (set-buffer buffer-before)
 ))

(defun laml-sync-process-current-buffer ()
  "Process the current buffer by SISC. The current buffer is supposed to be a laml buffer.
   Wait until finished. Before processing, save the current buffer."
  (interactive)
  (let* ((cur-dir (current-directory))
         (laml-output (get-buffer-create "sync-laml-output"))
         (file-path (concat (current-directory) (current-file)))
         (buf-name-1 (buffer-name (current-buffer)))
         (buf-name
             (if (buffer-versioned buf-name-1)
                 (buffer-without-version buf-name-1)
                 buf-name-1))
         (filename-without-extension (file-name-proper buf-name))
	 (laml-dir-string (concat "(begin (define laml-dir \\\"" laml-dir "\\\")"  "(define (laml-process file . args) (putprop 'argv '\\*environment-variables\\* (cons 'laml args)) (load file)))"))
	 )
    (save-buffer)
    (save-excursion
      (set-buffer laml-output)
      (erase-buffer))
    (message "Synchronous LAML processing. Please wait...")
    (call-process "/bin/csh" nil laml-output nil "-c" 
       (concat scheme-exec " -e \"" laml-dir-string  "\" -x -c laml-process -- " file-path " " (file-name-sans-extension buf-name-1) " " cur-dir))
    (message (last-buffer-line laml-output))))




; Ad hoc function used on Unix/SISC only:
(defun run-scheme-on-file (file-name)
  "Run Scheme silently on FILE-NAME"
   (call-process "/bin/sh" nil (get-buffer-create "laml-output") t "-c" 
     (concat scheme-exec " -x " " -f " " " file-name)))






