; Course plan presenters.

(define (course-plan-inner-node-presenter ast ast-name-path)
 (div (h2 "Course Plan Form Editor")
      (trivial-subtree-presentation ast ast-name-path)
      ))

(define (course-info-inner-node-presenter ast ast-name-path)
 (div
  (p) (hr) (p)
  (p (b "General information about the course:"))
  (course-info-attributes-presenter ast ast-name-path)
  (trivial-subtree-presentation ast ast-name-path)))

(define (time-list-inner-node-presenter ast ast-name-path)
  (div 
   (p) (hr) (p)
   (p (b "Sequential timing of individual lectures:"))
   (trivial-subtree-presentation ast ast-name-path)))


(define (header-caption-formatter x)
  (b (font-size 2 x)))

(define (lecture-list-inner-node-presenter ast ast-name-path)
  (div 
   (p) (hr) (p)
   (p (b "Lecture Description list:"))
   (table-3 0
     lecture-column-layout-list
     (list (map header-caption-formatter (list "Lecture id" "Subject id" "Plenum start" "Plenum length" "Exercise start" "Exercise length" "Room"))))
   (trivial-subtree-presentation ast ast-name-path) ))


(define (index-links-inner-node-presenter ast ast-name-path)
  (div 
   (p) (hr) (p)
   (p (b "Index links in left frame:"))
   (trivial-subtree-presentation ast ast-name-path)))

(define (bottom-links-inner-node-presenter ast ast-name-path)
  (div 
   (p) (hr) (p)
   (p (b "Links at the bottom of the main frame:"))
   (trivial-subtree-presentation ast ast-name-path)))


(define (subject-list-inner-node-presenter ast ast-name-path)
  (div 
   (p) (hr) (p)
   (p (b "Subject catalogue:"))
   (indent-pixels 10
    (trivial-subtree-presentation ast ast-name-path))))


; (define (subject-inner-node-presenter ast ast-name-path)
;  (div
;   (subject-attributes-presenter ast ast-name-path) (br)
;   (trivial-subtree-presentation ast ast-name-path) (vertical-space 1)))
; 
; (define (subject-attributes-presenter ast ast-name-path)
;  (let ((attributes (propertylist-to-alist (ast-attributes ast))))
;    (table-3 0
;     (list 200 500)
;     (list (map (lambda (a) (laml-forms-single-attribute-present a (ast-element-name ast) ast-name-path)) attributes)))))
; 
; (define subject-id-attribute-presenter
;  (lambda (apair name-path)
;   (div "Subject id: " (text-line name-path (as-string 10) (cdr apair)))))
; 
; (define subject-title-attribute-presenter
;  (lambda (apair name-path)
;   (div "Subject title: " (text-line name-path (as-string 50) (cdr apair)))))


(define (description-html-presenter ast cdata-name-path attributes-name-path)  ; not used
 (let ((html-contents (first (ast-subtrees ast))))
  (div "Subject description:" (br) (textarea-1 cdata-name-path 4 57 html-contents) (vertical-space 1))))

(define description-cdata-presenter description-html-presenter)



(define (course-info-attributes-presenter ast name-path)
 (div
  (let ((attributes (propertylist-to-alist (ast-attributes ast))))
    (table-3 0
      laml-forms-standard-two-column-layout-list
      (map (lambda (a p) (list (as-string (car a)) p))
           attributes
           (laml-forms-attribute-present-alist attributes "course-info" name-path))))
))

(define course-info-course-title-attribute-presenter (laml-form-text-line-presentation 40))
(define course-info-last-lecture-number-attribute-presenter (laml-form-text-line-presentation 2))
(define course-info-language-preference-attribute-presenter (laml-form-selection-presentation (list "danish" "english")))
(define course-info-color-scheme-attribute-presenter (laml-form-selection-presentation (list "purple-yellow" "red-yellow" "black-white" "blue-grey" "green-brown")))
(define course-info-brief-course-title-attribute-presenter (laml-form-text-line-presentation 10))
(define course-info-course-semester-attribute-presenter (laml-form-text-line-presentation 20))
(define course-info-brief-course-semester-attribute-presenter (laml-form-text-line-presentation 10))
(define course-info-teacher-name-attribute-presenter (laml-form-text-line-presentation 20))
(define course-info-course-url-prefix-attribute-presenter (laml-form-text-line-presentation 50))
(define course-info-author-home-url-attribute-presenter (laml-form-text-line-presentation 50))
(define course-info-make-overview-pages-attribute-presenter (laml-form-selection-presentation (list "true" "false")))


(define (time-attributes-presenter ast name-path)
 (div
  (let ((attributes (propertylist-to-alist (ast-attributes ast))))
   (if (= 5 (length attributes))
       (div 
         (laml-forms-single-attribute-present (second attributes) "time" name-path) " "
         (laml-forms-single-attribute-present (third attributes) "time" name-path) ", "
         (laml-forms-single-attribute-present (first attributes) "time" name-path) "  "
         (laml-forms-single-attribute-present (fourth attributes) "time" name-path) ":"
         (laml-forms-single-attribute-present (fifth attributes) "time" name-path))
       "???"))))

(define time-month-attribute-presenter (laml-form-selection-presentation-1  (map as-string (number-interval 1 12)) (vector->list month-name-english)))
(define time-day-attribute-presenter (laml-form-text-line-presentation 2))
(define time-year-attribute-presenter (laml-form-text-line-presentation 4))
(define time-hour-attribute-presenter (laml-form-text-line-presentation 2))
(define time-minute-attribute-presenter (laml-form-text-line-presentation 2))


(define lecture-column-layout-list (list 100 100 60 60 60 60 60))

(define (lecture-attributes-presenter ast name-path)
 (div
  (let ((attributes (propertylist-to-alist (ast-attributes ast))))
    (table-3 0
      lecture-column-layout-list
      (list (laml-forms-attribute-present-alist attributes "lecture" name-path))))))

(define lecture-lecture-id-attribute-presenter (laml-form-text-line-presentation 10))
(define lecture-subject-id-attribute-presenter (laml-form-text-line-presentation 10))
(define lecture-exercise-start-attribute-presenter (laml-form-text-line-presentation 3))
(define lecture-exercise-length-attribute-presenter (laml-form-text-line-presentation 3))
(define lecture-plenum-start-attribute-presenter (laml-form-text-line-presentation 3))
(define lecture-plenum-length-attribute-presenter (laml-form-text-line-presentation 3))
(define lecture-room-attribute-presenter (laml-form-text-line-presentation 5))

(define (link-entry-cdata-presenter ast cdata-name-path attributes-name-path)
 (let ((html-contents (first (ast-subtrees ast)))
      )
  (div (single-line-tabular-2 "Link anchor name" (text-line cdata-name-path 30 html-contents))
       (laml-forms-attribute-present ast attributes-name-path) 
       (vertical-space 1)
  )))

(define link-entry-href-attribute-presenter (laml-form-text-line-presentation 45))
(define link-entry-target-attribute-presenter (laml-form-text-line-presentation 8))


(define (course-intro-cdata-presenter ast cdata-name-path attributes-name-path)
 (let ((html-contents (first (ast-subtrees ast)))
      )
  (div (b "Course introduction:") (br)
       (textarea-1 cdata-name-path 8 70 html-contents) (p)
  )))

(define (lecture-plan-list-inner-node-presenter ast ast-name-path)
  (div 
   (p) (hr) (p)
   (p (b "Information about individual lecture pages:"))
   (indent-pixels 10
     (trivial-subtree-presentation ast ast-name-path))))

(define (lecture-plan-inner-node-presenter ast ast-name-path)
 (div
  (p) (hr) (p)
  (p (b "Lecture page content:")) 
  (lecture-plan-attributes-presentation ast ast-name-path) (br)
  (trivial-subtree-presentation ast ast-name-path) (vertical-space 1)))

(define (lecture-plan-attributes-presentation ast ast-name-path)
 (div
  (let ((attributes (propertylist-to-alist (ast-attributes ast))))
    (table-3 0
      laml-forms-standard-two-column-layout-list
      (map (lambda (a p) (list (as-string (car a)) p))
           attributes
           (laml-forms-attribute-present-alist attributes (ast-element-name ast) ast-name-path))))))

(define lecture-plan-lecture-id-attribute-presenter (laml-form-text-line-presentation 10))


(define (literature-cdata-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Literature:") (br) (textarea-1 cdata-name-path 4 70 html-contents))))

(define (literature-html-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Literature:") (br) (textarea-1 cdata-name-path 4 70 (xml-render html-contents)))))



(define (reading-guide-cdata-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Reading Guide:") (br)(textarea-1 cdata-name-path 4 70 html-contents))))

(define (reading-guide-html-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Reading Guide:") (br) (textarea-1 cdata-name-path 4 70 (xml-render html-contents)))))



(define (exercises-cdata-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Exercises:") (br) (textarea-1 cdata-name-path 4 70 html-contents))))

(define (exercises-html-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Exercises:") (br) (textarea-1 cdata-name-path 4 70 (xml-render html-contents)))))


(define (references-cdata-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "References:") (br) (textarea-1 cdata-name-path 4 70 html-contents))))

(define (references-html-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "References:") (br) (textarea-1 cdata-name-path 4 70 (xml-render html-contents)))))


(define (misc-cdata-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Miscellaneous:") (br)(textarea-1 cdata-name-path 4 70 html-contents))))

(define (misc-html-presenter ast cdata-name-path attributes-name-path) 
 (let ((html-contents (first (ast-subtrees ast))))
  (div (b "Miscellaneous:") (br) (textarea-1 cdata-name-path 4 70 (xml-render html-contents)))))


; Overview presentation

(define (lecture-plan-overview-presenter ast)
  (let ((lecture-id (defaulted-get-prop 'lecture-id (ast-attributes ast) #f)))
    (if lecture-id 
        (string-append (ast-element-name ast) " " lecture-id)
        (ast-element-name ast))))

(define (subject-overview-presenter ast)
  (let ((subject-id (defaulted-get-prop 'id (ast-attributes ast) #f)))
    (if subject-id 
        (string-append (ast-element-name ast) " " subject-id)
        (ast-element-name ast))))


